package allgemein.core;

import java.util.LinkedList;

public class UbchiAnalysis 
{
	int Plen = 0;
	int K1len = 0;
	int K2len = 0;
	int[][] pairs;
	boolean verbose=false;
	
	
	
	
	
	public static void main(String[] args) 
	{
		int[][] pairs = {{1,43}};
		//int[][] pairs = {{2,54}};
		//int[][] pairs = {{1,43},{2,54}};
		//int[][] pairs = {{3,48}};
		//int[][] pairs = {{1,43},{2,54},{3,48}};
		//int[][] pairs = {{1,43},{2,54},{3,48},{4,22},{5,11},{6,27},{7,8},{8,3}};

		UbchiAnalysis u = new UbchiAnalysis(58,8,6,pairs);
		System.out.println(u.calculateKeys());
			
	}
	
	
	
	
	
	
	
	
	public void setVerbose(boolean v)
	{
		this.verbose=v;
	}
	
	public UbchiAnalysis(int Plen, int K1len, int K2len, int[][] pairs)
	{
		this.Plen=Plen;
		this.K1len=K1len;
		this.K2len=K2len;
		this.pairs = pairs;
	}
	
	public KeyList calculateKeys()
	{
		return this.calculateKeys(null);
	}
	
	public KeyList calculateKeys(KeyList preKey)
	{
		// m1 = P/K1, m2 = P/K2
		int r1 = Plen % K1len;
		int r2 = Plen % K2len;
		int m1 = (int) Math.ceil((double) Plen / K1len);
		int m2 = (int) Math.ceil((double) Plen / K2len);

		if (r1==0) m1++;
		if (r2==0) m2++;
		
		
		
		KeyList last = null;
		if (preKey != null)
			last = preKey;

		for (int j = 0; j < pairs.length; j++)
		{
			if (verbose) System.out.println("Runde "+ (j+1));
			int i_alt = pairs[j][0];
			int i_neu = pairs[j][1];

			int s = 0, z = 0;
			// Koordinaten im Klartextwfel bestimmen
			for (int i = 0; i < m1; i++) {
				if (i_alt - i * K1len <= K1len && i_alt - i * K1len > 0) {
					z = i + 1;
					s = i_alt - i * K1len;
				}
			}

			LinkedList<int[]> K2res = new LinkedList<int[]>();
			LinkedList<int[]> K1res = new LinkedList<int[]>();
			if (verbose) System.out.println("K2 Liste aufstellen...");
			// u*(m2-1)+b+(t+1)
			for (int u = 0; u < K2len; u++) {
				for (int b = 0; b < u + 1 && b <= r2; b++)  
				{
					if (b >= u + (r2 - K2len)) //ab einem bestimmten u kann b nicht 0 sein
					{
						for (int t = 0; t <= m2 - 1; t++) {
							if (u * (m2 - 1) + b + (t + 1) == i_neu) {
								//System.out.println("u="+u + " b=" + b + " t="+t);
								K2res.add(new int[] { u, b, t });
							}
						}
					}
				}
			}

			if (verbose) System.out.println("K1 Liste aufstellen...");
			// v = (k1_s-1)*(m1-1) + a_4 + z - t*K2len
			for (int k1_s = 1; k1_s <= K1len; k1_s++) // ber alle mglichen
														// k1-schlssel
			{
				for (int[] k2r : K2res) // ber alle mglichen t
				{
					//int b = k2r[1];
					int t = k2r[2];
					//int u = k2r[0];
					for (int a_s = 0; a_s <= r1; a_s++) {
						if (a_s < k1_s && a_s >= (k1_s - 1) + (r1 - K1len)) 
						{
							int v = (k1_s - 1) * (m1 - 1) + a_s + z
									- (t * K2len);
						
							if (v > 0 && v <= K2len) {
								 //System.out.println("k1_s=" + k1_s + " a_s="+a_s + " v="+v);
								 K1res.add(new int[] { s, k1_s, a_s, v });
								
							}
						}
					}
				}
			}
			if (verbose) System.out.println("Datenstruktur aufbauen...");
			KeyList keys = new KeyList();
			for (int[] k1 : K1res) {
				Key K1 = new Key();

				int k1_s = k1[1];
				int a_s = k1[2];
				int v = k1[3];
				
				int[][] a = new int[K1len + 1][2];
				a[k1[0]] = new int[] { k1[1], k1[2] };
				
				
				K1.k = a;

				KeyList k2list = new KeyList();
				for (int[] k2 : K2res) {
					int b = k2[1];
					int t = k2[2];
					int u = k2[0];
					int k_v = k2[0]+1;
					
					if ((k1_s-1)*(m1-1)+a_s+z-t*K2len == v && u*(m2-1)+b+(t+1)==i_neu)
					{
					
						Key K2 = new Key();
						K2.k = new int[K2len + 1][2];
						K2.k[v] = new int[] { k_v, b };
						k2list.add(K2);
					}
					
				}
				K1.klist = k2list;

				keys.add(K1);
			}
			
			if (verbose) System.out.println("Mergen...");
			KeyList newList = new KeyList();
			if (last==null) last=keys;
			else
			{
				//merge zwischen last und den neuen keys
				int i=0;
				for (Key k1_1 : last)
				{
					if (verbose) 
						if (i++%100==0&&last.size()>100) System.out.println(i + "/" + last.size());
					for (Key k1_2 : keys)
					{
						//Merge zwischen k1_1 und k1_2
						
						//prfen ob ein wert doppelt an unterschiedlichen stellen vorliegt
						//merge aufrufen
						Key k1 = merge(k1_1, k1_2, r1);
						completeKey(k1,r1);
						if (k1!= null)
						{
							KeyList k2list = new KeyList();
							for (Key k2_1 : k1_1.klist) //merge von k2_1 und k2_2
							{
								for (Key k2_2 : k1_2.klist)
								{
										Key k2 = merge(k2_1,k2_2,r2);
										if (k2!=null && !k2list.contains(k2))
										{
												completeKey(k2,r2);
												k2list.add(k2);
										}
										
								}
							}
							k1.klist=k2list;
							
							if (k2list.size()!=0)
							{
								
								Key mk = newList.get(k1);
								if (mk==null)
									newList.add(k1);
								else
									mk.klist.append(k1.klist);
								
							}
						}
					}
				}
				last = newList;
			}
			if (verbose) System.out.println("Gre: " + last.size());
			System.gc();
		}
		if (verbose) System.out.println(last);
		if (verbose) System.out.println("Endgre: " + last.size());
		return last;
		
	}
	
	private static Key merge(Key k1, Key k2, int r)
	{
		boolean merge=true;
		Key k_new = new Key();
		k_new.k = new int[k1.k.length][2];
		
		for (int i_1=1;i_1<k1.k.length&&merge;i_1++)
		{
			for (int i_2=1;i_2<k2.k.length&&merge;i_2++)
			{
				if (k1.k[i_1][0] != 0 && k2.k[i_2][0] != 0)
				{
					if (k1.k[i_1][0] == k2.k[i_2][0]) //falls key-inhalt identisch
					{
						//falls schlssel identisch, mssen a/b Werte stimmen und die Position gleich sein
						if (k1.k[i_1][1] != k2.k[i_2][1] || (i_1 != i_2)) 
							merge=false;
						
					} else {
						// Falls key-inhalt nicht identisch
						if (i_1==i_2) //Falls schlsselinhalte nicht identisch jedoch an der gleichen Position
							merge=false;
						
						/*
						 * Falls k_i>k_j gilt, so muss auch a_i>=a_j gelten
						 */
						if (k1.k[i_1][0] > k2.k[i_2][0] && k1.k[i_1][1]<k2.k[i_2][1])
							merge = false;
						if (k1.k[i_1][0] < k2.k[i_2][0] && k1.k[i_1][1]>k2.k[i_2][1])
							merge = false;
						
						
						/*
						 * Falls die Spalte eine berlnge besitzt (i<r),
						 * so kann der a/b-Wert nicht r sein
						 */
						if (i_1<=r && k1.k[i_1][1]==r)
							merge=false;
						if (i_2<=r && k2.k[i_2][1]==r)
							merge=false;
							
					}
					
				}
			}
			if (merge)
			{
				if (k1.k[i_1][0]!=0)
					k_new.k[i_1]=k1.k[i_1];
				if (k2.k[i_1][0]!=0)
					k_new.k[i_1]=k2.k[i_1];
			}
		}
		
		
			//Weitere Konsistenzprfungen
		for (int i=1;i<k_new.k.length;i++)
		{				
			for (int j=1;j<k_new.k.length;j++)
			{
				
				if (k_new.k[i][0]!=0 && k_new.k[i][0]!=0)
				{
				/*
				 * Wenn der Schlsselwert k in einer berlangen Spalte sitzt
				 * dann gilt:
				 * Schlsselwert +1 -> a+1
				 * Schlsselwert +2 -> a+1,2
				 * Schlsselwert +3 -> a+1,2,3 
				 */
					if (k_new.k[i][0]<k_new.k[j][0] ) //falls Spalte<r und wird vorher eingefgt
					{
						//Betrachten des Schlsselwertabstands
						int delta_k = k_new.k[j][0] - k_new.k[i][0];
						//Betrachten des a/b-Abstands
						int delta_a = k_new.k[j][1] - k_new.k[i][1];
						
						if (delta_a>delta_k) //der Abstand von a kann nicht grer sein
							merge=false;
							
						if (i<=r) //falls es sich um eine berlange spalte gehandelt hat
						{	
							if (delta_a==0) //kann der Abstand nicht 0 sein
								merge=false;
						}
							
							
					}	
					
				}
			}
		}
		
	
		if (merge)
			return k_new;
			
		
		return null;
	}
	
	
	public static void completeKey(Key key, int r)
	{
		if (key==null) return;
		if (key.missing()!=1)
			return;
		
		for (int i=1;i<key.k.length;i++)
		{ 
			boolean found=false;
			int pos=0;
			for (int j=1;j<key.k.length;j++)
			{
				if (key.k[j][0]==i)
					found=true;
				if (key.k[j][0]==0)
					pos=j;
			}
			if (!found)
			{
				//es fehlt i an der stelle pos
				key.k[pos][0]=i;
				
				for (int j=1;j<key.k.length;j++)
					if (key.k[j][0]==(i-1))
					{
						if (j > r)
							key.k[pos][1]=key.k[j][1];
						else
							key.k[pos][1]=(key.k[j][1]+1);
					}
				
			}
		}
		
		
	}
}
