package allgemein.gui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JToolBar;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


public class Doppelwuerfel extends JFrame implements DoppelwuerfelListener {

	private static final long serialVersionUID = 1L;
	private DoppelwuerfelModel dwm;
	private DoppelwuerfelHandler dh;


	
	public static void main(String[] args)
	{	
		new Doppelwuerfel();	
	}
	
	
	public Doppelwuerfel() 
	{
		
		
		try {
		    UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		} catch (Exception e) {
		}
		initComponents();
		

		klarText.addKeyListener(
			new KeyListener() {

				@Override
				public void keyPressed(KeyEvent e) {
					klarLength.setText("Lnge " + klarText.getText().length());
				}

				@Override
				public void keyReleased(KeyEvent e) {
					// TODO Auto-generated method stub
					klarLength.setText("Lnge " + klarText.getText().length());
				}

				@Override
				public void keyTyped(KeyEvent e) {
					// TODO Auto-generated method stub
					klarLength.setText("Lnge " + klarText.getText().length());
				}
				
			});

		cipherText.addKeyListener(
				new KeyListener() {

					@Override
					public void keyPressed(KeyEvent e) {
						ciphLength.setText("Lnge " + cipherText.getText().length());
					}

					@Override
					public void keyReleased(KeyEvent e) {
						// TODO Auto-generated method stub
						ciphLength.setText("Lnge " + cipherText.getText().length());
					}

					@Override
					public void keyTyped(KeyEvent e) {
						// TODO Auto-generated method stub
						ciphLength.setText("Lnge " + cipherText.getText().length());
					}
					
				});
		
		k1SliderStart.addChangeListener(
				new ChangeListener() {
					public void stateChanged(ChangeEvent arg0) {
						k1Interval.setText(" " + k1SliderStart.getValue() + "-" + k1SliderEnd.getValue()+" ");	
					}
				}
		);
		k1SliderEnd.addChangeListener(
				new ChangeListener() {
					public void stateChanged(ChangeEvent arg0) {
						k1Interval.setText(" " + k1SliderStart.getValue() + "-" + k1SliderEnd.getValue()+" ");	
					}
				}
		);
		k2SliderStart.addChangeListener(
				new ChangeListener() {
					public void stateChanged(ChangeEvent arg0) {
						k2Interval.setText(" " + k2SliderStart.getValue() + "-" + k2SliderEnd.getValue()+" ");	
					}
				}
		);
		k2SliderEnd.addChangeListener(
				new ChangeListener() {
					public void stateChanged(ChangeEvent arg0) {
						k2Interval.setText(" " + k2SliderStart.getValue() + "-" + k2SliderEnd.getValue()+" ");	
					}
				}
		);
		
		incDelta.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						Integer i = Integer.parseInt(deltaLabel.getText());
						i++;
						deltaLabel.setText(""+i);
					}	
				}
		);
		
		decDelta.addActionListener(
				new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						Integer i = Integer.parseInt(deltaLabel.getText());
						if (i > 0)
						{
							i--;
							deltaLabel.setText(""+i);
						}
					}	
				}
		);
		
	
		
		
		/*Beispiel*/
		/*
		klarText.setText("Die EU-Kommission sieht in einer ersten Reaktion ihren Vorschlag fr ein abgespecktes EU-Gemeinschaftspatent nicht in Gefahr: Das Einheitspatent sei rechtlich abgekoppelt von der Einrichtung eines EU-Patentgerichts. Das Urteil werde daher keinen Einfluss haben auf den fr Donnerstag anstehenden Beschluss des Wettbewerbsrats, ein Einheitspatent auf dem Weg der verstrkten Zusammenarbeit einzufhren. Fr dieses Vorhaben hatte zuvor das EU-Parlament bereits grnes Licht gegeben. Parallel will die Kommission einen Weg suchen, eine Patentsgerichtsbarkeit zu installieren, die mit den EuGH-Magaben vereinbar ist.Die Luxemburger Richter folgten mit ihrer Bewertung weitgehend dem Schlussantrag der EU-Generalanwltin Juliane Kokott, uerten sich aber nicht konkret zur Frage der Verfahrenssprachen. Kokott hatte nicht nur die Plne fr die Umsetzung des Vorschlags als mangelhaft bezeichnet, sondern auch die vorgesehene Beschrnkung der Verfahrenssprachen auf Deutsch, Englisch oder Franzsisch. Die 27 EU-Staaten konnten sich im vergangenen Jahr nicht auf ein echtes Gemeinschaftspatent einigen. Vor allem Italien und Spanien waren gegen einen Vorsto von Binnenmarkt-Kommissar Michel Barnier, wonach Patentantrge nur noch in die drei Amtssprachen des Europischen Patentamts (EPA) Englisch, Deutsch und Franzsisch bersetzt werden sollen.");
		cipherText.setText(" Foafnnn et kweik tseunr ieeecedns hebfi faGlhEtnS msr  iuGoterenamptgianmtpserhzessttsecamas ntni2lrcrbtlpleDn.w rhi e mesr httaagaa, aithesrdettscanihherrUli)tegegi ezrs nh uwtreeeehivrvki KnuuFRUiin ncrsUrohnefsonudeoaeieb esleesfs eaiiapm t tv gssbltt uugcfiagren EmJtKreWio bcoaesBegitrEkcbea odne  Eehnednrido,  WssadidR  azPtnnsashtncnr egVonsantnf eDm see n  rdae se hcnehli ce FernsLkgggeikeiedntdnonm eeeuem cmEleAi vn, tioaSaeasi. oe-e l-Vliamehtd eeghs aK iefsgieiiplu hrrn ia,cs nBDen  mPaeeeMztt dhhrf rtiucro .DtecleWn biaietnateGeeieFttmtrtVsewIeitta ssans re drlgnusahgre Dnsrzma   iahrJ dignzP smc ernruaiunil,insefteEizae r gnl su ntretrmtegi ifefaiuhneschec -nilsshU trcee   dnsdfetstneelen sriti ufa Un.inuacE.c hmsae r s sc bVtn7bentsepeiieitltii-  oi e amoaD- t h tnsh gh s.arL ce nhkpKdtPuuiinntnVraed d ohst ssaa eelrvn hGhue nr-ebec.ftn rcneibteDee ertre,nthealleshnnnndenek eacelgtP  Etwrdoeredhnntrrlurnerceab(sreeaEsso  cngb c rEtla ehia  resf eckrrUxnnt  eoin   on ewcasnhs m   cdohrrMnnnhin,errrrUahowne unoi aewunnidste uoihsnsn a  oont htePnehgsuslnn Ei  halspnenzpratvsreEheh raP A diehh.e aheemwegeknciSitcnrir itrc mrsdh -ec nonEiceulit hsedeisBigeeeen t tE Vesd eaeaerbne KnaB tnoat nrengnlpttkt iV ngs:hBbZgoi - eabuunGr Ederenlr pehai,agHakaUmereatr  elkone nnahePvDr ghnupts sce g ingz");
		k1Slider.setValue(19);
		k2Slider.setValue(21);
		
		*/
		/**/
		//tabbedPane1.setSelectedIndex(1);
		
		this.dwm = new DoppelwuerfelModel();
		this.dh = new DoppelwuerfelHandler(this,dwm);
		this.statusList.setModel(new StatusListModel(dwm));
		this.resultTable.setModel(new ResultTableModel(dwm));
		
		
	
		try{
			this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		} catch (Exception e)
		{
		}
		
		
		this.setVisible(true);
	}
	
	public void setHandler(DoppelwuerfelHandler dh)
	{
		this.dh=dh;
		startButton.addActionListener(this.dh);
		stopButton.addActionListener(this.dh);
		missSlider.addChangeListener(this.dh);
	}

	

	private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
		// Generated using JFormDesigner Evaluation license - T W
		tabbedPane1 = new JTabbedPane();
		panel1 = new JPanel();
		panel2 = new JPanel();
		panel3 = new JPanel();
		panel4 = new JPanel();
		scrollPane1 = new JScrollPane();
		klarText = new JTextArea();
		klarLength = new JLabel();
		panel21 = new JPanel();
		panel24 = new JPanel();
		incDelta = new JButton();
		deltaLabel = new JLabel();
		decDelta = new JButton();
		panel5 = new JPanel();
		scrollPane2 = new JScrollPane();
		cipherText = new JTextArea();
		ciphLength = new JLabel();
		panel6 = new JPanel();
		panel11 = new JPanel();
		panel13 = new JPanel();
		panel8 = new JPanel();
		toolBar1 = new JToolBar();
		panel16 = new JPanel();
		panel20 = new JPanel();
		panel7 = new JPanel();
		missSlider = new JSlider();
		label6 = new JLabel();
		tabbedPane2 = new JTabbedPane();
		panel9 = new JPanel();
		panel14 = new JPanel();
		panel15 = new JPanel();
		label7 = new JLabel();
		k1Slider = new JSlider();
		panel17 = new JPanel();
		label8 = new JLabel();
		k2Slider = new JSlider();
		panel12 = new JPanel();
		panel18 = new JPanel();
		k1Interval = new JLabel();
		label2 = new JLabel();
		panel22 = new JPanel();
		k1SliderStart = new JSlider();
		k1SliderEnd = new JSlider();
		panel19 = new JPanel();
		k2Interval = new JLabel();
		label3 = new JLabel();
		panel23 = new JPanel();
		k2SliderStart = new JSlider();
		k2SliderEnd = new JSlider();
		label1 = new JLabel();
		startButton = new JButton();
		stopButton = new JButton();
		panel10 = new JPanel();
		scrollPane3 = new JScrollPane();
		statusList = new JList();
		scrollPane4 = new JScrollPane();
		resultTable = new JTable();

		//======== this ========
		setTitle("Doppelw\u00fcrfel");
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		//======== tabbedPane1 ========
		{

			//======== panel1 ========
			{

			}
			//tabbedPane1.addTab("Verschl\u00fcsselung", panel1);


			//======== panel2 ========
			{
				panel2.setLayout(new GridLayout(3, 1));

				//======== panel3 ========
				{
					panel3.setBorder(new TitledBorder(""));
					panel3.setLayout(new GridLayout(1, 2));

					//======== panel4 ========
					{
						panel4.setBorder(new TitledBorder("Klartext"));
						panel4.setLayout(new BorderLayout());

						//======== scrollPane1 ========
						{
							scrollPane1.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
							scrollPane1.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
							scrollPane1.setViewportBorder(null);

							//---- klarText ----
							klarText.setLineWrap(true);
							scrollPane1.setViewportView(klarText);
						}
						panel4.add(scrollPane1, BorderLayout.CENTER);

						//---- klarLength ----
						klarLength.setText("L\u00e4nge");
						panel4.add(klarLength, BorderLayout.SOUTH);

						//======== panel21 ========
						{
							panel21.setLayout(new BorderLayout());

							//======== panel24 ========
							{
								panel24.setLayout(new GridLayout(3, 0));

								//---- incDelta ----
								incDelta.setText("+");
								panel24.add(incDelta);

								//---- deltaLabel ----
								deltaLabel.setText("0");
								deltaLabel.setHorizontalAlignment(SwingConstants.CENTER);
								panel24.add(deltaLabel);

								//---- decDelta ----
								decDelta.setText("-");
								panel24.add(decDelta);
							}
							panel21.add(panel24, BorderLayout.CENTER);
						}
						panel4.add(panel21, BorderLayout.EAST);
					}
					panel3.add(panel4);

					//======== panel5 ========
					{
						panel5.setBorder(new TitledBorder("Chiffretext"));
						panel5.setLayout(new BorderLayout());

						//======== scrollPane2 ========
						{
							scrollPane2.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
							scrollPane2.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);

							//---- cipherText ----
							cipherText.setLineWrap(true);
							scrollPane2.setViewportView(cipherText);
						}
						panel5.add(scrollPane2, BorderLayout.CENTER);

						//---- ciphLength ----
						ciphLength.setText("L\u00e4nge");
						panel5.add(ciphLength, BorderLayout.SOUTH);
					}
					panel3.add(panel5);
				}
				panel2.add(panel3);

				//======== panel6 ========
				{
					panel6.setBorder(new TitledBorder(""));
					panel6.setLayout(new GridLayout(1, 1));

					//======== panel11 ========
					{
						panel11.setLayout(new GridLayout(1, 2));

						//======== panel13 ========
						{
							panel13.setLayout(new BorderLayout());

							//======== panel8 ========
							{
								panel8.setBorder(new TitledBorder("Steuerung"));
								panel8.setLayout(new GridLayout(1, 1));

								//======== toolBar1 ========
								{
									toolBar1.setRollover(true);

									//======== panel16 ========
									{
										panel16.setLayout(new BorderLayout());

										//======== panel20 ========
										{
											panel20.setLayout(new BorderLayout());

											//======== panel7 ========
											{
												panel7.setLayout(new BorderLayout());

												//---- missSlider ----
												missSlider.setMaximum(15);
												missSlider.setValue(4);
												missSlider.setMinorTickSpacing(1);
												missSlider.setMajorTickSpacing(1);
												missSlider.setSnapToTicks(true);
												missSlider.setPaintTicks(true);
												missSlider.setPaintLabels(true);
												panel7.add(missSlider, BorderLayout.CENTER);

												//---- label6 ----
												label6.setText("Fehlende");
												panel7.add(label6, BorderLayout.WEST);
											}
											panel20.add(panel7, BorderLayout.NORTH);

											//======== tabbedPane2 ========
											{

												//======== panel9 ========
												{
													panel9.setLayout(new BorderLayout());

													//======== panel14 ========
													{
														panel14.setLayout(new GridLayout(2, 1));

														//======== panel15 ========
														{
															panel15.setLayout(new BorderLayout());

															//---- label7 ----
															label7.setText("Schl\u00fcssel 1");
															panel15.add(label7, BorderLayout.WEST);

															//---- k1Slider ----
															k1Slider.setMaximum(30);
															k1Slider.setMinimum(1);
															k1Slider.setPaintLabels(true);
															k1Slider.setPaintTicks(true);
															k1Slider.setSnapToTicks(true);
															k1Slider.setValue(15);
															k1Slider.setMajorTickSpacing(1);
															k1Slider.setMinorTickSpacing(1);
															panel15.add(k1Slider, BorderLayout.CENTER);
														}
														panel14.add(panel15);

														//======== panel17 ========
														{
															panel17.setLayout(new BorderLayout());

															//---- label8 ----
															label8.setText("Schl\u00fcssel 2");
															panel17.add(label8, BorderLayout.WEST);

															//---- k2Slider ----
															k2Slider.setMaximum(30);
															k2Slider.setPaintTicks(true);
															k2Slider.setPaintLabels(true);
															k2Slider.setSnapToTicks(true);
															k2Slider.setValue(15);
															k2Slider.setMajorTickSpacing(1);
															k2Slider.setMinorTickSpacing(1);
															k2Slider.setMinimum(1);
															panel17.add(k2Slider, BorderLayout.CENTER);
														}
														panel14.add(panel17);
													}
													panel9.add(panel14, BorderLayout.CENTER);
												}
												tabbedPane2.addTab("Feste L\u00e4nge", panel9);


												//======== panel12 ========
												{
													panel12.setLayout(new GridLayout(2, 1));

													//======== panel18 ========
													{
														panel18.setLayout(new BorderLayout());

														//---- k1Interval ----
														k1Interval.setText(" 9-20 ");
														panel18.add(k1Interval, BorderLayout.EAST);

														//---- label2 ----
														label2.setText("Schl\u00fcssel 1  ");
														panel18.add(label2, BorderLayout.WEST);

														//======== panel22 ========
														{
															panel22.setLayout(new GridLayout(1, 2));

															//---- k1SliderStart ----
															k1SliderStart.setMinimum(1);
															k1SliderStart.setMaximum(30);
															k1SliderStart.setMajorTickSpacing(1);
															k1SliderStart.setMinorTickSpacing(1);
															k1SliderStart.setPaintTicks(true);
															k1SliderStart.setSnapToTicks(true);
															k1SliderStart.setValue(9);
															panel22.add(k1SliderStart);

															//---- k1SliderEnd ----
															k1SliderEnd.setMinimum(1);
															k1SliderEnd.setMaximum(30);
															k1SliderEnd.setMajorTickSpacing(1);
															k1SliderEnd.setMinorTickSpacing(1);
															k1SliderEnd.setPaintTicks(true);
															k1SliderEnd.setSnapToTicks(true);
															k1SliderEnd.setValue(20);
															panel22.add(k1SliderEnd);
														}
														panel18.add(panel22, BorderLayout.CENTER);
													}
													panel12.add(panel18);

													//======== panel19 ========
													{
														panel19.setLayout(new BorderLayout());

														//---- k2Interval ----
														k2Interval.setText(" 9-20 ");
														panel19.add(k2Interval, BorderLayout.EAST);

														//---- label3 ----
														label3.setText("Schl\u00fcssel 2  ");
														panel19.add(label3, BorderLayout.WEST);

														//======== panel23 ========
														{
															panel23.setLayout(new GridLayout(1, 2));

															//---- k2SliderStart ----
															k2SliderStart.setMaximum(30);
															k2SliderStart.setMinimum(1);
															k2SliderStart.setMinorTickSpacing(1);
															k2SliderStart.setMajorTickSpacing(1);
															k2SliderStart.setPaintTicks(true);
															k2SliderStart.setSnapToTicks(true);
															k2SliderStart.setValue(9);
															panel23.add(k2SliderStart);

															//---- k2SliderEnd ----
															k2SliderEnd.setMaximum(30);
															k2SliderEnd.setMinimum(1);
															k2SliderEnd.setMinorTickSpacing(1);
															k2SliderEnd.setMajorTickSpacing(1);
															k2SliderEnd.setPaintTicks(true);
															k2SliderEnd.setSnapToTicks(true);
															k2SliderEnd.setValue(20);
															panel23.add(k2SliderEnd);
														}
														panel19.add(panel23, BorderLayout.CENTER);
													}
													panel12.add(panel19);
												}
												tabbedPane2.addTab("Variable L\u00e4nge", panel12);

											}
											panel20.add(tabbedPane2, BorderLayout.CENTER);
										}
										panel16.add(panel20, BorderLayout.CENTER);
									}
									toolBar1.add(panel16);

									//---- label1 ----
									label1.setText("    ");
									toolBar1.add(label1);

									//---- startButton ----
									startButton.setText("Start");
									toolBar1.add(startButton);

									//---- stopButton ----
									stopButton.setText("Stop");
									toolBar1.add(stopButton);
								}
								panel8.add(toolBar1);
							}
							panel13.add(panel8, BorderLayout.CENTER);
						}
						panel11.add(panel13);
					}
					panel6.add(panel11);
				}
				panel2.add(panel6);

				//======== panel10 ========
				{
					panel10.setBorder(new TitledBorder("Ergebnisse"));
					panel10.setLayout(new GridLayout(1, 2));

					//======== scrollPane3 ========
					{
						scrollPane3.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
						scrollPane3.setViewportView(statusList);
					}
					panel10.add(scrollPane3);

					//======== scrollPane4 ========
					{
						scrollPane4.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

						//---- resultTable ----
						resultTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
						resultTable.setColumnSelectionAllowed(true);
						scrollPane4.setViewportView(resultTable);
					}
					panel10.add(scrollPane4);
				}
				panel2.add(panel10);
			}
			tabbedPane1.addTab("Kryptanalyse", panel2);

		}
		contentPane.add(tabbedPane1, BorderLayout.CENTER);
		setSize(815, 650);
		setLocationRelativeTo(getOwner());
		// JFormDesigner - End of component initialization  //GEN-END:initComponents
	}

	// JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
	// Generated using JFormDesigner Evaluation license - T W
	private JTabbedPane tabbedPane1;
	private JPanel panel1;
	private JPanel panel2;
	private JPanel panel3;
	private JPanel panel4;
	private JScrollPane scrollPane1;
	private JTextArea klarText;
	private JLabel klarLength;
	private JPanel panel21;
	private JPanel panel24;
	private JButton incDelta;
	private JLabel deltaLabel;
	private JButton decDelta;
	private JPanel panel5;
	private JScrollPane scrollPane2;
	private JTextArea cipherText;
	private JLabel ciphLength;
	private JPanel panel6;
	private JPanel panel11;
	private JPanel panel13;
	private JPanel panel8;
	private JToolBar toolBar1;
	private JPanel panel16;
	private JPanel panel20;
	private JPanel panel7;
	private JSlider missSlider;
	private JLabel label6;
	private JTabbedPane tabbedPane2;
	private JPanel panel9;
	private JPanel panel14;
	private JPanel panel15;
	private JLabel label7;
	private JSlider k1Slider;
	private JPanel panel17;
	private JLabel label8;
	private JSlider k2Slider;
	private JPanel panel12;
	private JPanel panel18;
	private JLabel k1Interval;
	private JLabel label2;
	private JPanel panel22;
	private JSlider k1SliderStart;
	private JSlider k1SliderEnd;
	private JPanel panel19;
	private JLabel k2Interval;
	private JLabel label3;
	private JPanel panel23;
	private JSlider k2SliderStart;
	private JSlider k2SliderEnd;
	private JLabel label1;
	private JButton startButton;
	private JButton stopButton;
	private JPanel panel10;
	private JScrollPane scrollPane3;
	private JList statusList;
	private JScrollPane scrollPane4;
	private JTable resultTable;





	
	
	
	@Override
	public void modelChanged() {
		// TODO Auto-generated method stub
		klarLength.setText("Lnge " + klarText.getText().length());
		ciphLength.setText("Lnge " + cipherText.getText().length());
		
		resultTable.updateUI();
		
		if (resultTable.getColumnCount()==4)
		{
			resultTable.getColumnModel().getColumn(0).setPreferredWidth(80);
			resultTable.getColumnModel().getColumn(1).setPreferredWidth(30);
			resultTable.getColumnModel().getColumn(2).setPreferredWidth(30);

			resultTable.getColumnModel().getColumn(3).setPreferredWidth(500);

		}
		
	}
	
	public String getKlartext()
	{
		return klarText.getText();
	}
	
	public String getCiphertext()
	{
		return cipherText.getText();
	}
	
	public int getMiss()
	{
		return missSlider.getValue();
	}
	
	public int getK1()
	{
		return k1Slider.getValue();
	}
	public int getK2()
	{
		return k2Slider.getValue();
	}
	
	public int getK1Start()
	{
		return k1SliderStart.getValue();
	}
	public int getK2Start()
	{
		return k2SliderStart.getValue();
	}
	
	public int getK1End()
	{
		return k1SliderEnd.getValue();
	}
	public int getK2End()
	{
		return k2SliderEnd.getValue();
	}
	
	
	public void refreshStatus()
	{
		statusList.updateUI();
	}
	
	public void setStartButtonStatus(boolean s)
	{
		startButton.setEnabled(s);
	}
	
	public void setStopButtonStatus(boolean s)
	{
		stopButton.setEnabled(s);
	}
	public void setK1SliderStatus(boolean s)
	{
		k1Slider.setEnabled(s);
	}
	public void setK2SliderStatus(boolean s)
	{
		k2Slider.setEnabled(s);
	}
	
	public int getKeyTabIndex()
	{
		return this.tabbedPane2.getSelectedIndex();
	}
	
	public int getDelta()
	{
		return Integer.parseInt(deltaLabel.getText());
	}
	
}
