package allgemein.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class DoppelwuerfelHandler implements ActionListener, ChangeListener, DoppelwuerfelListener
{
	
	private DoppelwuerfelModel dwm;
	private Doppelwuerfel dw;
	
	public DoppelwuerfelHandler(Doppelwuerfel dw, DoppelwuerfelModel dwm)
	{
		this.dw=dw;
		this.dwm=dwm;
		dwm.addListener(this);
		dw.setHandler(this);
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub
		Object o = arg0.getSource();
		
		if (o instanceof JButton)
		{
			JButton b = (JButton)o;
			
			String text = b.getText();
			if (text=="Start")
			{
				if (dw.getKeyTabIndex()==0) //normal
				{
					dwm.setSearchKey(false);
					dwm.setK1(dw.getK1());
					dwm.setK2(dw.getK2());
				}
				
				if (dw.getKeyTabIndex()==1) //schlsselsuche
				{
					dwm.setSearchKey(true);
					dwm.setK1(dw.getK1Start());
					dwm.setK2(dw.getK2Start());
					dwm.setK1End(dw.getK1End());
					dwm.setK2End(dw.getK2End());
				}
				dwm.setDelta(dw.getDelta());
				dwm.setCiphertext(dw.getCiphertext());
				dwm.setPlaintext(dw.getKlartext());
				dwm.setMiss(dw.getMiss());
				dwm.start();
			}
			
			if (text=="Stop")
			{
				dwm.stop();
			}
		}
	}

	@Override
	public void stateChanged(ChangeEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void modelChanged() {
		// TODO Auto-generated method stub
		dw.refreshStatus();
		
		dw.modelChanged();
		
		dw.setStartButtonStatus(!dwm.isRunning());
		dw.setStopButtonStatus(dwm.isRunning());
		dw.setK1SliderStatus(!dwm.isRunning());
		dw.setK2SliderStatus(!dwm.isRunning());
	}
}
